@echo off
cd /d "%~dp0"
color 0e
title mRatio Fixer v7 / Service Installer

if not exist nssm.--- (
	title mRatio Fixer v7 / Error
	echo nssm.--- is missing.
	goto exit
)

for %%a in (mitmproxy-dhparam.pem mitmproxy-ca-cert.pem mitmproxy-ca-cert.p12 mitmproxy-ca-cert.cer mitmproxy-ca.pem mitmproxy-ca.p12) do if not exist %%a (
	title mRatio Fixer v7 / Error
	echo One or more certificate files are missing.
	echo Before running this script, you must open start.bat ^(to generate the
	echo root certificate^) and install_cert.bat ^(to install it^) first.
	goto exit
)

rem Cheap (but effective) method of checking for administrator privileges
net session 1>nul 2>&1 && goto main
title mRatio Fixer v7 / Error
echo This script requires administrator privileges. To run it, you should:
echo   * Right-click on %~nx0
echo   * Click on "Run as administrator"
echo   * Click on "Yes" in the User Account Control prompt
echo.
echo Press any key to exit...&pause >nul&exit /b

:main
echo This will install the mitmproxy used by mRatio Fixer as a system
echo service. This means it will have no visible interface and will have to
echo be controlled via services.msc or SC.EXE/NET.EXE instead.
echo.
echo Log and error messages will go to mitmproxy.log instead of the console
echo window. Note that said log file will never be deleted or rotated, so
echo you'll have to do it by hand if it gets too big.
echo.
echo Also note that:
echo   * You must have run start.bat ^(to generate the root certificate^)
echo     and install_cert.bat ^(to install it^) beforehand.
echo   * mRatio Fixer cannot run both in interactive mode and as a service,
echo     so make sure it's closed before proceeding.
echo.
:prompt
choice /c yn /n /m "Do you want to install the mitmproxy service now? (y/n)"
if %ERRORLEVEL%==1 echo Okay, continuing.&goto next
if %ERRORLEVEL%==2 goto exit
echo Invalid choice, press a key and try again.
pause >nul
goto prompt

:next
echo.
echo Making sure no mitmproxy service exists already...
net stop mitmproxy 1>nul 2>&1
sc delete mitmproxy 1>nul 2>&1
del /f /q mitmproxy.log 1>nul 2>&1

echo Installing mitmproxy service...
rem Thanks to Iain Patterson for nssm
rem https://nssm.cc/
nssm.--- install mitmproxy "%cd%\mitmdump.---" 1>nul 2>&1
nssm.--- set mitmproxy Application "%cd%\mitmdump.---" 1>nul 2>&1
nssm.--- set mitmproxy AppDirectory "%cd%" 1>nul 2>&1
nssm.--- set mitmproxy AppParameters "--confdir """%cd%"""" 1>nul 2>&1
nssm.--- set mitmproxy DisplayName "mitmproxy" 1>nul 2>&1
nssm.--- set mitmproxy Description "mitmproxy service used by mRatio Fixer" 1>nul 2>&1
nssm.--- set mitmproxy Start SERVICE_DELAYED_AUTO_START 1>nul 2>&1
nssm.--- set mitmproxy ObjectName LocalSystem 1>nul 2>&1
nssm.--- set mitmproxy Type SERVICE_WIN32_OWN_PROCESS 1>nul 2>&1
nssm.--- set mitmproxy DependOnService "" 1>nul 2>&1
nssm.--- set mitmproxy AppPriority NORMAL_PRIORITY_CLASS 1>nul 2>&1
nssm.--- set mitmproxy AppNoConsole 1 1>nul 2>&1
nssm.--- set mitmproxy AppAffinity All 1>nul 2>&1
nssm.--- set mitmproxy AppStopMethodSkip 0 1>nul 2>&1
nssm.--- set mitmproxy AppStopMethodConsole 5000 1>nul 2>&1
nssm.--- set mitmproxy AppStopMethodWindow 5000 1>nul 2>&1
nssm.--- set mitmproxy AppStopMethodThreads 5000 1>nul 2>&1
nssm.--- set mitmproxy AppThrottle 5000 1>nul 2>&1
nssm.--- set mitmproxy AppExit Default Restart 1>nul 2>&1
nssm.--- set mitmproxy AppRestartDelay 10000 1>nul 2>&1
nssm.--- set mitmproxy AppStdout "%cd%\mitmproxy.log" 1>nul 2>&1
nssm.--- set mitmproxy AppStderr "%cd%\mitmproxy.log" 1>nul 2>&1

echo Done.

:prompt2
choice /c yn /n /m "Do you want to start the mitmproxy service now? (y/n)"
if %ERRORLEVEL%==1 (
	echo Starting service...
	net start mitmproxy 1>nul 2>&1
	goto exit
)
if %ERRORLEVEL%==2 goto exit
echo Invalid choice, press a key and try again.
pause >nul
goto prompt2

:exit
echo Press any key to exit...
pause >nul
exit /b
